unit MouseControl;

interface

uses
  Windows, Classes, Controls;

type tMouseButtonstate = (bsUp,bsDown);
type
  TMouseControl = class(TComponent)
  private
    pt: tpoint;
    Fmousebutton: tmousebutton;
    fmbstate: Tmousebuttonstate;
    procedure setcurrentX(const Value: integer);
    procedure setcurrenty(const Value: integer);
    function getpositiony: integer;
    function getpositionx: integer;
    procedure setposition;
    procedure setbtnstate(const Value: tmousebuttonstate);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    procedure MouseUp;
    procedure MouseDown;
    procedure MouseClick;
    property Button: tmousebutton read fmousebutton write fmousebutton default mbleft;
    property ButtonState: tmousebuttonstate read fmbstate write setbtnstate default bsUp;
    property Y: integer read getpositiony write setcurrenty;
    property X: integer read getpositionx write setcurrentX;
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('System', [TMouseControl]);
end;

{ TMouseControl }

procedure TMouseControl.MouseUp;
begin
  case fmousebutton of
//left button clicked;
    mbleft:
      begin
        mouse_event(mouseeventf_leftup, 0, 0, 0, 0);
      end;
//middle button clicked;
    mbmiddle:
      begin
        mouse_event(mouseeventf_middleup, 0, 0, 0, 0);
      end;
//right button clicked;
    mbright:
      begin
        mouse_event(mouseeventf_rightup, 0, 0, 0, 0);
      end;
  end;
fmbstate:=bsUp;
end;

function TMouseControl.getpositionx: integer;
begin
  getcursorpos(pt);
  result := pt.x;
end;

function TMouseControl.getpositiony: integer;
begin
  getcursorpos(pt);
  result := pt.y;
end;


procedure TMouseControl.setcurrentX(const Value: integer);
begin
  pt.x := value;
  setposition;
end;

procedure TMouseControl.setcurrenty(const Value: integer);
begin
  pt.y := Value;
  setposition;
end;

procedure TMouseControl.setposition;
begin
  setcursorpos(pt.x, pt.y);
end;

procedure TMouseControl.MouseDown;
begin
  case fmousebutton of
//left button clicked;
    mbleft:
      begin
        mouse_event(mouseeventf_leftdown, 0, 0, 0, 0);
      end;
//middle button clicked;
    mbmiddle:
      begin
        mouse_event(mouseeventf_middledown, 0, 0, 0, 0);
      end;
//right button clicked;
    mbright:
      begin
        mouse_event(mouseeventf_rightdown, 0, 0, 0, 0);
      end;
  end;
fmbstate:=bsdown;
end;

procedure TMouseControl.MouseClick;
begin
  mousedown;
  mouseup;
end;

procedure TMouseControl.setbtnstate(const Value: tmousebuttonstate);
begin
  if value = bsUp then mouseup;
  if value = bsDown then mousedown;
  fmbstate := Value;
end;

end.

